interface CspConfig {
    [key: string]: string | string[];
}
declare type ConfigName = "csp.js" | "csp.json";
declare type ConfigExtension = "js" | "json";
declare type Mutate<T, U> = Pick<T, Exclude<keyof T, keyof U>> & U;
declare type TemplateElement = Mutate<HTMLTemplateElement, {
    content: Mutate<DocumentFragment, {
        firstChild: Element;
    }>;
}>;
export { ConfigName, CspConfig, ConfigExtension, TemplateElement };
